From 88e230f27926566fdb64599f286d69c038f0907b Mon Sep 17 00:00:00 2001
From: Felix Kaechele <felix@fetzig.org>
Date: Mon, 15 Apr 2013 23:43:38 +0200
Subject: [PATCH 3/5] [ramips] add Poray X5/X6 support

---
 target/linux/ramips/base-files/etc/diag.sh         |   3 +
 .../ramips/base-files/etc/uci-defaults/02_network  |   3 +-
 .../ramips/base-files/lib/preinit/06_set_iface_mac |   3 +-
 target/linux/ramips/base-files/lib/ramips.sh       |   3 +
 .../ramips/base-files/lib/upgrade/platform.sh      |   3 +-
 target/linux/ramips/dts/X5.dts                     | 126 +++++++++++++++++++++
 target/linux/ramips/image/Makefile                 |   3 +
 target/linux/ramips/rt305x/profiles/poray.mk       |  10 ++
 8 files changed, 151 insertions(+), 3 deletions(-)
 create mode 100644 target/linux/ramips/dts/X5.dts

diff --git a/target/linux/ramips/base-files/etc/diag.sh b/target/linux/ramips/base-files/etc/diag.sh
index b1dfeea..4e81222 100755
--- a/target/linux/ramips/base-files/etc/diag.sh
+++ b/target/linux/ramips/base-files/etc/diag.sh
@@ -129,6 +129,9 @@ get_status_led() {
 	ur-336un)
 		status_led="ur336:green:wps"
 		;;
+	x5)
+		status_led="x5:green:power"
+		;;
 	xdxrn502j)
 		status_led="xdxrn502j:green:power"
 		;;
diff --git a/target/linux/ramips/base-files/etc/uci-defaults/02_network b/target/linux/ramips/base-files/etc/uci-defaults/02_network
index 6cbe0ef..8739036 100755
--- a/target/linux/ramips/base-files/etc/uci-defaults/02_network
+++ b/target/linux/ramips/base-files/etc/uci-defaults/02_network
@@ -212,7 +212,8 @@ ramips_setup_macs()
 		;;
 
 	m3 | \
-	m4)
+	m4 | \
+	x5)
 		lan_mac=$(mtd_get_mac_binary factory 4)
 		lan_mac=$(macaddr_add "$lan_mac" -1)
 		;;
diff --git a/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac b/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
index 623ebd3..9e84720 100644
--- a/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
+++ b/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
@@ -70,7 +70,8 @@ preinit_set_mac_address() {
 		ifconfig eth0 hw ether $mac 2>/dev/null
 		;;
 	m3 |\
-	m4)
+	m4 |\
+	x5)
 		mac=$(mtd_get_mac_binary factory 4)
 		mac=$(macaddr_add "$mac" -1)
 		ifconfig eth0 hw ether $mac 2>/dev/null
diff --git a/target/linux/ramips/base-files/lib/ramips.sh b/target/linux/ramips/base-files/lib/ramips.sh
index 3a56837..b91d6a2 100755
--- a/target/linux/ramips/base-files/lib/ramips.sh
+++ b/target/linux/ramips/base-files/lib/ramips.sh
@@ -147,6 +147,9 @@ ramips_board_detect() {
 	*"Poray M4")
 		name="m4"
 		;;
+	*"Poray X5")
+		name="x5"
+		;;
 	*"PWH2004")
 		name="pwh2004"
 		;;
diff --git a/target/linux/ramips/base-files/lib/upgrade/platform.sh b/target/linux/ramips/base-files/lib/upgrade/platform.sh
index d46e4ee..f51f289 100755
--- a/target/linux/ramips/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ramips/base-files/lib/upgrade/platform.sh
@@ -66,7 +66,8 @@ platform_check_image() {
 	whr-g300n |\
 	ur-326n4g |\
 	ur-336un |\
-	wr512-3gn)
+	wr512-3gn |\
+	x5)
 		[ "$magic" != "27051956" ] && {
 			echo "Invalid image type."
 			return 1
diff --git a/target/linux/ramips/dts/X5.dts b/target/linux/ramips/dts/X5.dts
new file mode 100644
index 0000000..d076ed7
--- /dev/null
+++ b/target/linux/ramips/dts/X5.dts
@@ -0,0 +1,126 @@
+/dts-v1/;
+
+/include/ "rt5350.dtsi"
+
+/ {
+	compatible = "X5", "ralink,rt5350-soc";
+	model = "Poray X5";
+
+	palmbus@10000000 {
+		sysc@0 {
+			ralink,pinmux = "i2c", "spi", "uartlite", "mdio", "sdram", "rgmii";
+			ralink,gpiomux = "jtag";
+			ralink,uartmux = "gpio";
+			ralink,wdtmux = <1>;
+		};
+
+		gpio0: gpio@600 {
+			status = "okay";
+		};
+
+		spi@b00 {
+			status = "okay";
+			m25p80@0 {
+				#address-cells = <1>;
+				#size-cells = <1>;
+				compatible = "gd25q64";
+				reg = <0 0>;
+				linux,modalias = "m25p80", "gd25q64";
+				spi-max-frequency = <10000000>;
+
+		partition@0 {
+			label = "u-boot";
+			reg = <0x0 0x30000>;
+			read-only;
+		};
+
+		partition@30000 {
+			label = "u-boot-env";
+			reg = <0x30000 0x10000>;
+			read-only;
+		};
+
+		factory: partition@40000 {
+			label = "factory";
+			reg = <0x40000 0x10000>;
+			read-only;
+		};
+
+		partition@50000 {
+			label = "firmware";
+			reg = <0x50000 0x7b0000>;
+		};
+			};
+		};
+	};
+
+	ethernet@10100000 {
+		status = "okay";
+	};
+
+	esw@10110000 {
+		status = "okay";
+		ralink,portmap = <0x2f>;
+	};
+
+	gpio-leds {
+		compatible = "gpio-leds";
+		power {
+			label = "x5:green:power";
+			gpios = <&gpio0 13 1>;
+		};
+		
+		20 {
+			label = "x5:green:20";
+			gpios = <&gpio0 12 1>;
+		};
+		
+		50 {
+			label = "x5:green:50";
+			gpios = <&gpio0 11 1>;
+		};
+		
+		80 {
+			label = "x5:green:80";
+			gpios = <&gpio0 7 1>;
+		};
+	};
+
+	gpio-keys-polled {
+		compatible = "gpio-keys-polled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		poll-interval = <20>;
+
+		bat {
+			label = "bat";
+			gpios = <&gpio0 9 1>;
+			linux,code = <0x211>;
+		};
+
+		reset {
+			label = "reset";
+			gpios = <&gpio0 10 1>;
+			linux,code = <0x198>;
+		};
+
+		mode {
+			label = "mode";
+			gpios = <&gpio0 14 1>;
+			linux,code = <0x100>;
+		};
+	};
+
+	wmac@10180000 {
+		status = "okay";
+		ralink,mtd-eeprom = <&factory 0>;
+	};
+
+	ehci@101c0000 {
+		status = "okay";
+	};
+
+	ohci@101c1000 {
+		status = "okay";
+	};
+};
diff --git a/target/linux/ramips/image/Makefile b/target/linux/ramips/image/Makefile
index 2f46bbf..3e623cc 100644
--- a/target/linux/ramips/image/Makefile
+++ b/target/linux/ramips/image/Makefile
@@ -416,6 +416,8 @@ Image/Build/Profile/UR-336UN=$(call BuildFirmware/Default8M/$(1),$(1),ur-336un,U
 
 Image/Build/Profile/WR6202=$(call BuildFirmware/Default8M/$(1),$(1),wr6202,WR6202)
 
+Image/Build/Profile/X5=$(call BuildFirmware/Default8M/$(1),$(1),x5,X5)
+
 Image/Build/Profile/XDXRN502J=$(call BuildFirmware/Default4M/$(1),$(1),xdxrn502j,XDXRN502J)
 
 ifeq ($(SUBTARGET),rt305x)
@@ -472,6 +474,7 @@ define Image/Build/Profile/Default
 	$(call Image/Build/Profile/WNCE2001,$(1))
 	$(call Image/Build/Profile/WR512-3GN,$(1))
 	$(call Image/Build/Profile/WR6202,$(1))
+	$(call Image/Build/Profile/X5,$(1))
 	$(call Image/Build/Profile/XDXRN502J,$(1))
 endef
 endif
diff --git a/target/linux/ramips/rt305x/profiles/poray.mk b/target/linux/ramips/rt305x/profiles/poray.mk
index 64948e9..2b61086 100644
--- a/target/linux/ramips/rt305x/profiles/poray.mk
+++ b/target/linux/ramips/rt305x/profiles/poray.mk
@@ -27,3 +27,13 @@ define Profile/M4/Description
 endef
 
 $(eval $(call Profile,M4))
+
+define Profile/X5
+	NAME:=Poray X5/X6
+	PACKAGES:=kmod-usb-core kmod-usb2 kmod-ledtrig-netdev kmod-ledtrig-timer
+endef
+define Profile/X5/Description
+	Package set for Poray X5/X6 board
+endef
+
+$(eval $(call Profile,X5))
-- 
1.8.2.1