From 9bb06d3f2ef158699970ad1ab493380f8a34c53d Mon Sep 17 00:00:00 2001
From: Felix Kaechele <felix@fetzig.org>
Date: Mon, 15 Apr 2013 23:47:16 +0200
Subject: [PATCH 4/5] [ramips] add Poray X8 support

---
 target/linux/ramips/base-files/etc/diag.sh         |  3 +
 .../ramips/base-files/etc/uci-defaults/02_network  |  3 +-
 .../ramips/base-files/lib/preinit/06_set_iface_mac |  3 +-
 target/linux/ramips/base-files/lib/ramips.sh       |  3 +
 .../ramips/base-files/lib/upgrade/platform.sh      |  3 +-
 target/linux/ramips/dts/X8.dts                     | 99 ++++++++++++++++++++++
 target/linux/ramips/image/Makefile                 |  3 +
 target/linux/ramips/rt305x/profiles/poray.mk       | 10 +++
 8 files changed, 124 insertions(+), 3 deletions(-)
 create mode 100644 target/linux/ramips/dts/X8.dts

diff --git a/target/linux/ramips/base-files/etc/diag.sh b/target/linux/ramips/base-files/etc/diag.sh
index 4e81222..e260f26 100755
--- a/target/linux/ramips/base-files/etc/diag.sh
+++ b/target/linux/ramips/base-files/etc/diag.sh
@@ -132,6 +132,9 @@ get_status_led() {
 	x5)
 		status_led="x5:green:power"
 		;;
+	x8)
+		status_led="x8:green:power"
+		;;
 	xdxrn502j)
 		status_led="xdxrn502j:green:power"
 		;;
diff --git a/target/linux/ramips/base-files/etc/uci-defaults/02_network b/target/linux/ramips/base-files/etc/uci-defaults/02_network
index 8739036..bc7170a 100755
--- a/target/linux/ramips/base-files/etc/uci-defaults/02_network
+++ b/target/linux/ramips/base-files/etc/uci-defaults/02_network
@@ -213,7 +213,8 @@ ramips_setup_macs()
 
 	m3 | \
 	m4 | \
-	x5)
+	x5 | \
+	x8)
 		lan_mac=$(mtd_get_mac_binary factory 4)
 		lan_mac=$(macaddr_add "$lan_mac" -1)
 		;;
diff --git a/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac b/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
index 9e84720..d8f2dbc 100644
--- a/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
+++ b/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
@@ -71,7 +71,8 @@ preinit_set_mac_address() {
 		;;
 	m3 |\
 	m4 |\
-	x5)
+	x5 |\
+	x8)
 		mac=$(mtd_get_mac_binary factory 4)
 		mac=$(macaddr_add "$mac" -1)
 		ifconfig eth0 hw ether $mac 2>/dev/null
diff --git a/target/linux/ramips/base-files/lib/ramips.sh b/target/linux/ramips/base-files/lib/ramips.sh
index b91d6a2..4b124c5 100755
--- a/target/linux/ramips/base-files/lib/ramips.sh
+++ b/target/linux/ramips/base-files/lib/ramips.sh
@@ -150,6 +150,9 @@ ramips_board_detect() {
 	*"Poray X5")
 		name="x5"
 		;;
+	*"Poray X8")
+		name="x8"
+		;;
 	*"PWH2004")
 		name="pwh2004"
 		;;
diff --git a/target/linux/ramips/base-files/lib/upgrade/platform.sh b/target/linux/ramips/base-files/lib/upgrade/platform.sh
index f51f289..83ef77a 100755
--- a/target/linux/ramips/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ramips/base-files/lib/upgrade/platform.sh
@@ -67,7 +67,8 @@ platform_check_image() {
 	ur-326n4g |\
 	ur-336un |\
 	wr512-3gn |\
-	x5)
+	x5 |\
+	x8)
 		[ "$magic" != "27051956" ] && {
 			echo "Invalid image type."
 			return 1
diff --git a/target/linux/ramips/dts/X8.dts b/target/linux/ramips/dts/X8.dts
new file mode 100644
index 0000000..f3f4beb
--- /dev/null
+++ b/target/linux/ramips/dts/X8.dts
@@ -0,0 +1,99 @@
+/dts-v1/;
+
+/include/ "rt5350.dtsi"
+
+/ {
+	compatible = "X8", "ralink,rt5350-soc";
+	model = "Poray X8";
+
+	palmbus@10000000 {
+		sysc@0 {
+			ralink,pinmux = "i2c", "spi", "uartlite", "mdio", "sdram", "rgmii";
+			ralink,gpiomux = "jtag";
+			ralink,uartmux = "gpio";
+			ralink,wdtmux = <1>;
+		};
+
+		gpio0: gpio@600 {
+			status = "okay";
+		};
+
+		spi@b00 {
+			status = "okay";
+			m25p80@0 {
+				#address-cells = <1>;
+				#size-cells = <1>;
+				compatible = "gd25q64";
+				reg = <0 0>;
+				linux,modalias = "m25p80", "gd25q64";
+				spi-max-frequency = <10000000>;
+
+		partition@0 {
+			label = "u-boot";
+			reg = <0x0 0x30000>;
+			read-only;
+		};
+
+		partition@30000 {
+			label = "u-boot-env";
+			reg = <0x30000 0x10000>;
+			read-only;
+		};
+
+		factory: partition@40000 {
+			label = "factory";
+			reg = <0x40000 0x10000>;
+			read-only;
+		};
+
+		partition@50000 {
+			label = "firmware";
+			reg = <0x50000 0x7b0000>;
+		};
+			};
+		};
+	};
+
+	ethernet@10100000 {
+		status = "okay";
+	};
+
+	esw@10110000 {
+		status = "okay";
+		ralink,portmap = <0x2f>;
+	};
+
+	gpio-leds {
+		compatible = "gpio-leds";
+		power {
+			label = "x8:green:power";
+			gpios = <&gpio0 13 1>;
+		};
+	};
+
+	gpio-keys-polled {
+		compatible = "gpio-keys-polled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		poll-interval = <20>;
+
+		reset {
+			label = "reset";
+			gpios = <&gpio0 10 1>;
+			linux,code = <0x198>;
+		};
+	};
+
+	wmac@10180000 {
+		status = "okay";
+		ralink,mtd-eeprom = <&factory 0>;
+	};
+
+	ehci@101c0000 {
+		status = "okay";
+	};
+
+	ohci@101c1000 {
+		status = "okay";
+	};
+};
diff --git a/target/linux/ramips/image/Makefile b/target/linux/ramips/image/Makefile
index 3e623cc..655f711 100644
--- a/target/linux/ramips/image/Makefile
+++ b/target/linux/ramips/image/Makefile
@@ -418,6 +418,8 @@ Image/Build/Profile/WR6202=$(call BuildFirmware/Default8M/$(1),$(1),wr6202,WR620
 
 Image/Build/Profile/X5=$(call BuildFirmware/Default8M/$(1),$(1),x5,X5)
 
+Image/Build/Profile/X8=$(call BuildFirmware/Default8M/$(1),$(1),x8,X8)
+
 Image/Build/Profile/XDXRN502J=$(call BuildFirmware/Default4M/$(1),$(1),xdxrn502j,XDXRN502J)
 
 ifeq ($(SUBTARGET),rt305x)
@@ -475,6 +477,7 @@ define Image/Build/Profile/Default
 	$(call Image/Build/Profile/WR512-3GN,$(1))
 	$(call Image/Build/Profile/WR6202,$(1))
 	$(call Image/Build/Profile/X5,$(1))
+	$(call Image/Build/Profile/X8,$(1))
 	$(call Image/Build/Profile/XDXRN502J,$(1))
 endef
 endif
diff --git a/target/linux/ramips/rt305x/profiles/poray.mk b/target/linux/ramips/rt305x/profiles/poray.mk
index 2b61086..ca06dcd 100644
--- a/target/linux/ramips/rt305x/profiles/poray.mk
+++ b/target/linux/ramips/rt305x/profiles/poray.mk
@@ -37,3 +37,13 @@ define Profile/X5/Description
 endef
 
 $(eval $(call Profile,X5))
+
+define Profile/X8
+	NAME:=Poray X8
+	PACKAGES:=kmod-usb-core kmod-usb2 kmod-ledtrig-netdev kmod-ledtrig-timer
+endef
+define Profile/X8/Description
+	Package set for Poray X8 board
+endef
+
+$(eval $(call Profile,X8))
-- 
1.8.2.1