From 7b740bf7b894453591471fe57086e3dce3300a3c Mon Sep 17 00:00:00 2001
From: Felix Kaechele <felix@fetzig.org>
Date: Tue, 16 Apr 2013 00:04:01 +0200
Subject: [PATCH 5/5] [ramips] add Poray IP2202 support

---
 target/linux/ramips/base-files/etc/diag.sh         |  3 +
 .../ramips/base-files/etc/uci-defaults/02_network  |  1 +
 .../ramips/base-files/lib/preinit/06_set_iface_mac |  1 +
 target/linux/ramips/base-files/lib/ramips.sh       |  3 +
 .../ramips/base-files/lib/upgrade/platform.sh      |  1 +
 target/linux/ramips/dts/IP2202.dts                 | 97 ++++++++++++++++++++++
 target/linux/ramips/image/Makefile                 |  3 +
 target/linux/ramips/rt305x/profiles/poray.mk       | 12 +++
 8 files changed, 121 insertions(+)
 create mode 100644 target/linux/ramips/dts/IP2202.dts

diff --git a/target/linux/ramips/base-files/etc/diag.sh b/target/linux/ramips/base-files/etc/diag.sh
index e260f26..dbadbee 100755
--- a/target/linux/ramips/base-files/etc/diag.sh
+++ b/target/linux/ramips/base-files/etc/diag.sh
@@ -42,6 +42,9 @@ get_status_led() {
 	fonera20n)
 		status_led="fonera20n:green:power"
 		;;
+	ip2202)
+		status_led="ip2202:green:run"
+		;;
 	rt-n13u)
 		status_led="rt-n13u:power"
 		;;
diff --git a/target/linux/ramips/base-files/etc/uci-defaults/02_network b/target/linux/ramips/base-files/etc/uci-defaults/02_network
index bc7170a..d1f96e2 100755
--- a/target/linux/ramips/base-files/etc/uci-defaults/02_network
+++ b/target/linux/ramips/base-files/etc/uci-defaults/02_network
@@ -165,6 +165,7 @@ ramips_setup_macs()
 	br6425 | \
 	broadway | \
 	f5d8235-v1 | \
+	ip2202 | \
 	mzk-w300nh2 | \
 	nw718 | \
 	psr-680w | \
diff --git a/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac b/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
index d8f2dbc..1d24562 100644
--- a/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
+++ b/target/linux/ramips/base-files/lib/preinit/06_set_iface_mac
@@ -25,6 +25,7 @@ preinit_set_mac_address() {
 	dir-620-a1 |\
 	esr-9753 |\
 	freestation5 |\
+	ip2202 |\
 	nw718 |\
 	psr-680w |\
 	rt-n56u |\
diff --git a/target/linux/ramips/base-files/lib/ramips.sh b/target/linux/ramips/base-files/lib/ramips.sh
index 4b124c5..e023834 100755
--- a/target/linux/ramips/base-files/lib/ramips.sh
+++ b/target/linux/ramips/base-files/lib/ramips.sh
@@ -141,6 +141,9 @@ ramips_board_detect() {
 	*"Planex MZK-W300NH2"*)
 		name="mzk-w300nh2"
 		;;
+	*"Poray IP2202")
+		name="ip2202"
+		;;
 	*"Poray M3")
 		name="m3"
 		;;
diff --git a/target/linux/ramips/base-files/lib/upgrade/platform.sh b/target/linux/ramips/base-files/lib/upgrade/platform.sh
index 83ef77a..76d0b52 100755
--- a/target/linux/ramips/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ramips/base-files/lib/upgrade/platform.sh
@@ -38,6 +38,7 @@ platform_check_image() {
 	rt-n13u | \
 	freestation5 | \
 	hw550-3g | \
+	ip2202 | \
 	m3 | \
 	m4 | \
 	mofi3500-3gn | \
diff --git a/target/linux/ramips/dts/IP2202.dts b/target/linux/ramips/dts/IP2202.dts
new file mode 100644
index 0000000..ceafc2e
--- /dev/null
+++ b/target/linux/ramips/dts/IP2202.dts
@@ -0,0 +1,97 @@
+/dts-v1/;
+
+/include/ "rt3050.dtsi"
+
+/ {
+	compatible = "IP2202", "ralink,rt3052-soc";
+	model = "Poray IP2202";
+
+	palmbus@10000000 {
+		sysc@0 {
+			ralink,pinmux = "i2c", "spi", "uartlite", "jtag", "sdram", "rgmii";
+			ralink,gpiomux = "mdio";
+			ralink,uartmux = "gpio";
+			ralink,wdtmux = <1>;
+		};
+
+		gpio0: gpio@600 {
+			status = "okay";
+		};
+
+	};
+
+	cfi@1f000000 {
+		compatible = "cfi-flash";
+		reg = <0x1f000000 0x800000>;
+
+		bank-width = <2>;
+		device-width = <2>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		partition@0 {
+			label = "u-boot";
+			reg = <0x0 0x30000>;
+			read-only;
+		};
+
+		partition@30000 {
+			label = "u-boot-env";
+			reg = <0x30000 0x10000>;
+			read-only;
+		};
+
+		factory: partition@40000 {
+			label = "factory";
+			reg = <0x40000 0x10000>;
+			read-only;
+		};
+
+		partition@50000 {
+			label = "firmware";
+			reg = <0x50000 0x7b0000>;
+		};
+	};
+
+	ethernet@10100000 {
+		status = "okay";
+	};
+
+	esw@10110000 {
+		status = "okay";
+		ralink,portmap = <0x2f>;
+	};
+
+	gpio-leds {
+		compatible = "gpio-leds";
+		run {
+			label = "ip2202:green:run";
+			gpios = <&gpio0 9 1>;
+		};
+		
+		net {
+			label = "ip2202:amber:net";
+			gpios = <&gpio0 13 1>;
+		};
+	};
+
+	gpio-keys-polled {
+		compatible = "gpio-keys-polled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		poll-interval = <20>;
+		reset {
+			label = "reset";
+			gpios = <&gpio0 10 1>;
+			linux,code = <0x198>;
+		};
+	};
+
+	wmac@10180000 {
+		status = "okay";
+	};
+
+	otg@101c0000 {
+		status = "okay";
+	};
+};
diff --git a/target/linux/ramips/image/Makefile b/target/linux/ramips/image/Makefile
index 655f711..a2c9c3c 100644
--- a/target/linux/ramips/image/Makefile
+++ b/target/linux/ramips/image/Makefile
@@ -317,6 +317,8 @@ Image/Build/Profile/RT-N13U=$(call BuildFirmware/Default8M/$(1),$(1),rt-n13u,RT-
 
 Image/Build/Profile/FREESTATION5=$(call BuildFirmware/Default8M/$(1),$(1),freestation5,FREESTATION5)
 
+Image/Build/Profile/IP2202=$(call BuildFirmware/Default8M/$(1),$(1),ip2202,IP2202)
+
 Image/Build/Profile/M3=$(call BuildFirmware/Default4M/$(1),$(1),m3,M3)
 
 Image/Build/Profile/M4=$(call BuildFirmware/DefaultDualSize/$(1),$(1),m4,M4)
@@ -449,6 +451,7 @@ define Image/Build/Profile/Default
 	$(call Image/Build/Profile/FONERA20N,$(1))
 	$(call Image/Build/Profile/FREESTATION5,$(1))
 	$(call Image/Build/Profile/HW550-3G,$(1))
+	$(call Image/Build/Profile/IP2202,$(1))
 	$(call Image/Build/Profile/M3,$(1))
 	$(call Image/Build/Profile/M4,$(1))
 	$(call Image/Build/Profile/MOFI3500-3GN,$(1))
diff --git a/target/linux/ramips/rt305x/profiles/poray.mk b/target/linux/ramips/rt305x/profiles/poray.mk
index ca06dcd..ed6f37c 100644
--- a/target/linux/ramips/rt305x/profiles/poray.mk
+++ b/target/linux/ramips/rt305x/profiles/poray.mk
@@ -7,6 +7,18 @@
 # See /LICENSE for more information.
 #
 
+define Profile/IP2202
+	NAME:=Poray IP2202
+	PACKAGES:=kmod-usb-core kmod-usb2 kmod-usb-rt305x-dwc_otg \
+	kmod-ledtrig-netdev kmod-ledtrig-timer restorefactory
+endef
+
+define Profile/IP2202/Description
+	Package set for Poray IP2202 board
+endef
+
+$(eval $(call Profile,IP2202))
+
 define Profile/M3
 	NAME:=Poray M3
 	PACKAGES:=kmod-usb-core kmod-usb2 kmod-ledtrig-netdev kmod-ledtrig-timer
-- 
1.8.2.1